// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// dstack.h
//
// Stack container class using deque as container.

#ifndef _DSTACK_H
#define _DSTACK_H

#include <stack>
#include <deque>

template<class T>
class Stack
	{
public:
	typedef stack< deque<T> >::size_type size_type;
	typedef stack< deque<T> >::value_type value_type;
	typedef deque<T>::iterator iterator;

	bool empty()      const        { return c.empty(); }
	size_type size()  const        { return c.size(); }
	value_type&       top()        { return c.top(); }
	const value_type& top() const  { return c.top(); }
	void push(const value_type &x) { c.push(x); }
	void pop()                     { c.pop(); }

protected:
	stack< deque<T> > c;
	};

#endif // _DSTACK_H
