// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// st_eval.h
//
// Function object to evaluate a symbol table node.  The only nodes
// that can be evaluated right now are net and function nodes.

#ifndef _ST_EVAL_H
#define _ST_EVAL_H

#include "common/st_node.h"

class func_enable;

struct evaluate_st_node : public st_node_evaluate
	{
	typedef st_node_evaluate::num_type num_type;
	typedef func_enable func_caller_type;

	evaluate_st_node(const func_caller_type * = 0);
	num_type operator()(const st_net *) const;
	num_type operator()(const st_function *) const;

	const func_caller_type *_caller;
	};

#endif // _ST_EVAL_H

