// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// st_inst.cc

#include "common/st_inst.h"

st_instantiation::st_instantiation(const str_type &n)
	: _name(n)
	{ }

const st_instantiation::str_type
st_instantiation::type_name() const
	{ return "instantiation"; }

const st_instantiation::str_type
st_instantiation::name() const
	{ return _name; }

const st_instantiation::scope_type
st_instantiation::scope() const
	{ return _scope; }

void
st_instantiation::scope(scope_type sc)
	{ _scope = sc; }

st_instantiation *
st_instantiation::get_instantiation()
	{ return this; }

st_instantiation::ostream_type &
st_instantiation::display(ostream_type &s) const
	{
	s << "('" << _name << "'," << type_name() << ',' << _scope << ')';
	return s;
	}

void
st_instantiation::sim_setup(const setup_type &setup)
	{ setup(this); }

ostream &
operator<<(ostream &s, const st_instantiation &mod)
	{ return mod.display(s); }
