// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// st_inst.h
//
// Symbol table object to support module instantiation.

#ifndef _ST_INST_H
#define _ST_INST_H

#include "common/st_node.h"

class st_instantiation : public st_node_base
	{
	friend struct setup_st_node;

public:
	st_instantiation(const str_type &);

	const str_type type_name() const;
	const str_type name() const;
	const scope_type scope() const;
	void scope(scope_type);
	st_instantiation *get_instantiation();

	ostream_type &display(ostream_type &s) const;
	void sim_setup(const setup_type &);

private:
	scope_type _scope;
	str_type _name;
	};

ostream &operator<<(ostream &, const st_instantiation &);

#endif // _ST_INST_H
