// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// st_trig.cc

#include "common/st_task.h"
#include "common/st_trig.h"
#include "common/st_util.h"
#include "common/st_trig.h"
#include "stmt/taskenbl.h"
#include "stmt/strigger.h"

trigger_st_node::trigger_st_node(task_caller_type *t)
	{ _caller = t; }

bool
trigger_st_node::operator()(st_task *p) const
	{
	// Initialize local variables.
	if (p->_iovariable != 0)
		entry_iovars(*(p->_iovariable), *(_caller->_argument));
	// Trigger statement and pass in the caller.  The argument is
	// usually the parent statement, but the trigger function needs
	// data from the caller if the task is a system task.
	const st_task::str_type &name = p->name();
	bool status(false);
	if (name[0] == '$')
		status = p->_stmt->sim_trigger(trigger_stmt(_caller));
	else
		status = p->_stmt->sim_trigger(trigger_stmt(p->_stmt));
	// Set output variables.
	if (p->_iovariable != 0)
		exit_iovars(*(p->_iovariable), *(_caller->_argument));
	return status;
	}
