// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// st_util.h
//
// Utilities used by STfunction and STtask objects.

#ifndef _STUTIL_H
#define _STUTIL_H

#include <string>
#include <list>
#include "common/hash.h"
#include "common/error.h"

struct expr_base;

void entry_iovars(list<hash_value> &, list< basic_ptr<expr_base> > &);
void exit_iovars(list<hash_value> &, list< basic_ptr<expr_base> > &);
void print_escapecode(const string &, size_t &);
bool find_format(size_t &, const string &, string &);
bool check_arguments(list< basic_ptr<expr_base> > *, list<hash_value> *);
SIM_ERR_NUM check_format(const string &);

#endif // _STUTIL_H
