// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// tmpl_utl.h
//
// A function object to delete list contents.

#ifndef _TMPL_UTL_H
#define _TMPL_UTL_H

#include <list>

template<class T>
struct printlist
	{
	typedef list<T> list_type;

	void operator()(list_type *lst) const
		{
		if (lst != 0)
			{
			list_type::iterator itp(lst->begin());
			list_type::iterator stop(lst->end());
			for (; itp != stop; ++itp)
				cout << (*itp) << endl;
			}
		}
	};

template<class T>
struct ptrprintlist
	{
	typedef list<T> list_type;

	void operator()(list_type *lst) const
		{
		if (lst != 0)
			{
			list_type::iterator itp(lst->begin());
			list_type::iterator stop(lst->end());
			for (; itp != stop; ++itp)
				cout << *(*itp) << endl;
			}
		}
	};

#endif // _TMPL_UTL_H
