// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// eeval.h

#ifndef _EEVAL_H
#define _EEVAL_H

#include "expr/exprbase.h"

struct evaluate_expr : public expr_evaluate
	{
	num_type operator()(const add *) const;
	num_type operator()(const and_and *) const;
	num_type operator()(const equal_equal *) const;
	num_type operator()(const func_enable *) const;
	num_type operator()(const grt_equal *) const;
	num_type operator()(const grt_than *) const;
	num_type operator()(const invert *) const;
	num_type operator()(const left_shift *) const;
	num_type operator()(const les_equal *) const;
	num_type operator()(const les_than *) const;
	num_type operator()(const logic_and *) const;
	num_type operator()(const logic_or *) const;
	num_type operator()(const logic_xor *) const;
	num_type operator()(const not_expr *) const;
	num_type operator()(const not_equal *) const;
	num_type operator()(const number *) const;
	num_type operator()(const or_or *) const;
	// qouted_str, use default.
	num_type operator()(const range_id *) const;
	num_type operator()(const right_shift *) const;
	num_type operator()(const sub *) const;
	};

#endif // _EEVAL_H
