// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// emon.h

#ifndef _EMON_H
#define _EMON_H

#include "common/ptr.h"
#include "expr/exprbase.h"
#include "stmt/stmtbase.h"

struct monitor_expr : public expr_monitor
	{
	typedef stmt_base stmt_type;
	typedef event_base<stmt_type> event_type;
	typedef counted_ptr<event_type> event_ptr;

	monitor_expr(event_ptr *);

	bool operator()(const add *) const;
	bool operator()(const and_and *) const;
	bool operator()(const equal_equal *) const;
	bool operator()(const func_enable *) const;
	bool operator()(const grt_equal *) const;
	bool operator()(const grt_than *) const;
	bool operator()(const invert *) const;
	bool operator()(const left_shift *) const;
	bool operator()(const les_equal *) const;
	bool operator()(const les_than *) const;
	bool operator()(const logic_and *) const;
	bool operator()(const logic_or *) const;
	bool operator()(const logic_xor *) const;
	bool operator()(const not_expr *) const;
	bool operator()(const not_equal *) const;
	bool operator()(const number *) const;
	bool operator()(const or_or *) const;
	bool operator()(const qouted_str *) const;
	bool operator()(const range_id *) const;
	bool operator()(const right_shift *) const;
	bool operator()(const sub *) const;

	event_ptr *_event;
	};

#endif // _EMON_H
