// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// esetup.h

#ifndef _ESETUP_H
#define _ESETUP_H

#include "common/dstack.h"
#include "common/event.h"
#include "expr/exprbase.h"
#include "expr/funcenbl.h"

struct stmt_base;
class st_function;
class st_net;

struct setup_expr : public expr_setup
	{
	typedef Stack<int> scopelist_type;
	typedef expr_base expr_type;
	typedef expr_type::num_type num_type;
	typedef stmt_base stmt_type;
	typedef func_enable func_caller_type;
	typedef func_caller_type::arg_list arg_list;
	typedef st_function func_type;
	typedef st_net net_type;

	setup_expr(scopelist_type &);

	void operator()(add *) const;
	void operator()(and_and *) const;
	void operator()(equal_equal *) const;
	void operator()(func_enable *) const;
	void operator()(grt_equal *) const;
	void operator()(grt_than *) const;
	void operator()(invert *) const;
	void operator()(left_shift *) const;
	void operator()(les_equal *) const;
	void operator()(les_than *) const;
	void operator()(logic_and *) const;
	void operator()(logic_or *) const;
	void operator()(logic_xor *) const;
	void operator()(not_expr *) const;
	void operator()(not_equal *) const;
	// No need setup number.
	void operator()(or_or *) const;
	// No need setup qouted_str.
	void operator()(range_id *) const;
	void operator()(right_shift *) const;
	void operator()(sub *) const;

	scopelist_type &_scope;
	};

#endif // _ESETUP_H
