// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// etrigger.h

#ifndef _ETRIGGER_H
#define _ETRIGGER_H

#include "expr/exprbase.h"

struct trigger_expr : public expr_trigger
	{
	typedef expr_base expr_type;
	typedef expr_type::str_type str_type;
	typedef expr_type::num_type num_type;

	trigger_expr(str_type &);

	void operator()(add *) const;
	void operator()(and_and *) const;
	void operator()(equal_equal *) const;
	void operator()(func_enable *) const;
	void operator()(grt_equal *) const;
	void operator()(grt_than *) const;
	void operator()(invert *) const;
	void operator()(left_shift *) const;
	void operator()(les_equal *) const;
	void operator()(les_than *) const;
	void operator()(logic_and *) const;
	void operator()(logic_or *) const;
	void operator()(logic_xor *) const;
	void operator()(not_expr *) const;
	void operator()(not_equal *) const;
	void operator()(number *) const;
	void operator()(or_or *) const;
	void operator()(qouted_str *) const;
	void operator()(range_id *) const;
	void operator()(right_shift *) const;
	void operator()(sub *) const;

	str_type &_format;
	};

#endif // _ETRIGGER_H
