// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// grtthan.cc

#include "expr/grtthan.h"

grt_than::grt_than(expr_type *l, expr_type *r)
	{ _left = l; _right = r; }

grt_than::grt_than(const grt_than &p)
	: common_base(p), expr_base(p)
	{
	_left = p._left->copy_constructor();
	_right = p._right->copy_constructor();
	}

grt_than::~grt_than()
	{ delete _left; delete _right; }

grt_than *
grt_than::copy_constructor() const
	{ return new grt_than(*this); }

grt_than::ostream_type &
grt_than::display(ostream_type &s) const
	{ return display_binary_expr(s, *_left, *_right, ">"); }

bool
grt_than::sim_monitor(const monitor_type &mon) const
	{ return mon(this); }

grt_than::num_type
grt_than::sim_evaluate(const evaluate_type &eval) const
	{ return eval(this); }

void
grt_than::sim_setup(const setup_type &setup)
	{ setup(this); }

void
grt_than::sim_trigger(const trigger_type &trigger)
	{ trigger(this); }

ostream &
operator<<(ostream &s, const grt_than &d)
	{ return d.display(s); }
