// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// invert.h

#include "expr/invert.h"

invert::invert(expr_type *e)
	{ _expr = e; }

invert::invert(const invert &p)
	: common_base(p), expr_base(p)
	{ _expr = p._expr->copy_constructor(); }

invert::~invert()
	{ delete _expr; }

invert *
invert::copy_constructor() const
	{ return new invert(*this); }

invert::ostream_type &
invert::display(ostream_type &s) const
	{ return display_unary_expr(s, *_expr, '~'); }

bool
invert::sim_monitor(const monitor_type &mon) const
	{ return mon(this); }

invert::num_type
invert::sim_evaluate(const evaluate_type &eval) const
	{ return eval(this); }

void
invert::sim_setup(const setup_type &setup)
	{ setup(this); }

void
invert::sim_trigger(const trigger_type &trigger)
	{ trigger(this); }

ostream &
operator<<(ostream &s, const invert &d)
	{ return d.display(s); }
