// Verilog Behavioral Simulator
// Copyright (C) 1995 Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// logxor.h

#ifndef _LOGXOR_H
#define _LOGXOR_H

#include "expr/exprbase.h"

class logic_xor : public expr_base
	{
	friend struct monitor_expr;
	friend struct evaluate_expr;
	friend struct setup_expr;
	friend struct trigger_expr;

public:
	typedef expr_base expr_type;

	logic_xor(expr_type *, expr_type *);
	logic_xor(const logic_xor &);
	~logic_xor();

	logic_xor *copy_constructor() const;
	ostream_type &display(ostream_type &) const;
	bool sim_monitor(const monitor_type &) const;
	num_type sim_evaluate(const evaluate_type &) const;
	void sim_setup(const setup_type &);
	void sim_trigger(const trigger_type &);

private:
	expr_type *_left;
	expr_type *_right;
	};

ostream &operator<<(ostream &, const logic_xor &);

#endif // _LOGXOR_H
