// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// not.cc

#include "expr/not.h"

not_expr::not_expr(expr_type *e)
	{ _expr = e; }

not_expr::not_expr(const not_expr &p)
	: common_base(p), expr_base(p)
	{ _expr = p._expr->copy_constructor(); }

not_expr::~not_expr()
	{ delete _expr; }

not_expr *
not_expr::copy_constructor() const
	{ return new not_expr(*this); }

not_expr::ostream_type &
not_expr::display(ostream_type &s) const
	{ return display_unary_expr(s, *_expr, '!'); }

bool
not_expr::sim_monitor(const monitor_type &mon) const
	{ return mon(this); }

not_expr::num_type
not_expr::sim_evaluate(const evaluate_type &eval) const
	{ return eval(this); }

void
not_expr::sim_setup(const setup_type &setup)
	{ setup(this); }

void
not_expr::sim_trigger(const trigger_type &trigger)
	{ trigger(this); }

ostream &
operator<<(ostream &s, const not_expr &d)
	{ return d.display(s); }
