// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// qstr.cc

#include "expr/qstr.h"

qouted_str::qouted_str(const char *s)
	: str_type(s, strlen(s))
	{}

qouted_str::qouted_str(const qouted_str &p)
	: common_base(p), expr_base(p), string(p)
	{
	// This must be a bug, the call to the copy constructor of
	// common_base should have done the job.
	_filename = p._filename;
	_lineno = p._lineno;
	}

qouted_str *
qouted_str::get_qouted_str()
	{ return this; }

qouted_str *
qouted_str::copy_constructor() const
	{ return new qouted_str(*this); }

qouted_str::ostream_type &
qouted_str::display(ostream_type &s) const
	{
	const str_type *str = this;
	s << *str;
	return s;
	}

bool
qouted_str::sim_monitor(const monitor_type &mon) const
	{ return mon(this); }

void
qouted_str::sim_trigger(const trigger_type &trigger)
	{ trigger(this); }

ostream &
operator<<(ostream &s, const qouted_str &d)
	{ return d.display(s); }
