// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// qstr.h

#ifndef _QSTR_H
#define _QSTR_H

#include "expr/exprbase.h"

class qouted_str : public expr_base, public string
	{
	friend struct trigger_expr;

public:
	typedef str_type::value_type value_type;
	typedef str_type::size_type size_type;

	qouted_str(const char *);
	qouted_str(const qouted_str &);

	qouted_str *get_qouted_str();
	qouted_str *copy_constructor() const;
	ostream_type &display(ostream_type &) const;
	bool sim_monitor(const monitor_type &) const;
	void sim_trigger(const trigger_type &);
	};

ostream &operator<<(ostream &, const qouted_str &);

#endif // _QSTR_H
