// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// bit.cc

#include "misc/bit.h"
#include "expr/eeval.h"

bit::bit(expr_type *e)
	{ _expr = e; }

bit::bit(const bit &p)
	: common_base(p), select_base(p)
	{ _expr = p._expr->copy_constructor(); }

bit::select_size_type
bit::get_data(position_type &e, position_type &) const
	{
	e = (unsigned long)_expr->sim_evaluate(evaluate_expr());
	return select_type::SELECT_BIT;
	}

bit *
bit::copy_constructor() const
	{ return new bit(*this); }

bit::ostream_type &
bit::display(ostream_type &s) const
	{
	s << '[' << *_expr << ']';
	return s;
	}

void
bit::sim_setup(const setup_type &setup)
	{ setup(this); }

ostream &
operator<<(ostream &s, const bit &b)
	{ return b.display(s); }
