// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// bit.h

#ifndef _BIT_H
#define _BIT_H

#include "misc/selbase.h"
#include "expr/exprbase.h"

class bit : public select_base
	{
	friend struct setup_select;

public:
	typedef select_base select_type;
	typedef expr_base expr_type;

	bit(expr_type *);
	bit(const bit &);

	select_size_type get_data(position_type &, position_type &) const;
	bit *copy_constructor() const;
	ostream_type &display(ostream &) const;
	void sim_setup(const setup_type &);

private:
	expr_type *_expr;
	};

ostream &operator<<(ostream &, const bit &);

#endif // _BIT_H
