// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// cexpr.cc

#include "misc/cexpr.h"
#include "expr/eeval.h"

const_expr::const_expr(const expr_type *e)
	{ _amount = e->sim_evaluate(evaluate_expr()); }

const_expr::ostream_type &
const_expr::display(ostream_type &s) const
	{ s << _amount; return s; }

const_expr::num_type
const_expr::amount() const
	{ return _amount; }

ostream &
operator<<(ostream &s, const const_expr &d)
	{ return d.display(s); }
