// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// cexpr.h

#ifndef _CEXPR_H
#define _CEXPR_H

#include "expr/exprbase.h"

class const_expr : public common_base
	{
public:
	typedef expr_base expr_type;
	typedef expr_type::num_type num_type;

	const_expr(const expr_type *);

	ostream_type &display(ostream_type &) const;
	num_type amount() const;

private:
	num_type _amount;
	};

ostream &operator<<(ostream &, const const_expr &);

#endif // _CEXPR_H
