// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// decsetup.h

#ifndef _DECSETUP_H
#define _DECSETUP_H

#include "common/dstack.h"
#include "misc/decbase.h"
#include "misc/evntexpr.h"
#include "stmt/stmtbase.h"

class st_net;

struct setup_event_expr : public event_expr_setup
	{
	typedef Stack<int> scopelist_type;
	typedef stmt_base stmt_type;
	typedef stmt_type::expr_type expr_type;
	typedef expr_type::num_type num_type;

	setup_event_expr(scopelist_type &);
	void operator()(event_expr *) const;

	scopelist_type &_scope;
	};


struct setup_dec : public dec_setup
	{
	typedef Stack<int> scopelist_type;
	typedef st_net net_type;

	setup_dec(scopelist_type &); 
	void operator()(delay_id *) const;
	void operator()(ored_event_expr *) const;

	scopelist_type &_scope;
	};

#endif // _DECSETUP_H
