// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// dectrig.h

#ifndef _DECTRIG_H
#define _DECTRIG_H

#include "common/event.h"
#include "stmt/stmtbase.h"
#include "misc/evntexpr.h"
#include "misc/decbase.h"

class st_net;

struct trigger_event_expr : public event_expr_trigger
	{
	typedef stmt_base stmt_type;
	typedef event_expr::expr_type::num_type num_type;
	typedef event_base<stmt_type> event_type;
	typedef event_type::event_container event_cache_type;

	trigger_event_expr(event_cache_type *);
	void operator()(event_expr *) const;

	event_cache_type *_cache;
	};


struct trigger_dec : public dec_trigger
	{
	typedef stmt_base stmt_type;
	typedef stmt_type::expr_type expr_type;
	typedef expr_type::num_type num_type;
	typedef event_base<stmt_type> event_type;
	typedef event_type::event_container event_cache_type;
	typedef st_net net_type;

	trigger_dec(stmt_type *);
	void operator()(delay_num *) const;
	void operator()(delay_id *) const;
	void operator()(ored_event_expr *) const;

	stmt_type *_stmt;
	};

#endif // _DECTRIG_H
