// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// delayid.cc

#include "misc/delayid.h"

delay_id::delay_id(const char *id)
	: _index(), _name(id)
	{}

delay_id::delay_id(const delay_id &p)
	: common_base(p), dec_base(p), _index(p._index), _name(p._name)
	{}

delay_id *
delay_id::copy_constructor() const
	{ return new delay_id(*this); }

delay_id::ostream_type &
delay_id::display(ostream_type &s) const
	{
	s << '#' << _name << ' ';
	return s;
	}

void
delay_id::sim_setup(const setup_type &setup)
	{ setup(this); }

void
delay_id::sim_trigger(const trigger_type &trigger)
	{ trigger(this); }

ostream &
operator<<(ostream &s, const delay_id &d)
	{ return d.display(s); }
