// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// delayid.h

#ifndef _DELAYID_H
#define _DELAYID_H

#include "common/hash.h"
#include "misc/decbase.h"

class delay_id : public dec_base
	{
	friend struct setup_dec;
	friend struct trigger_dec;

public:
	typedef hash_value hash_type;

	delay_id(const char *);
	delay_id(const delay_id &);

	delay_id *copy_constructor() const;
	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);
	void sim_trigger(const trigger_type &);

private:
	hash_type _index; // Index into symbol table.
	string _name;
	};

ostream &operator<<(ostream &, const delay_id &);

#endif // _DELAYID_H
