// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// delaynum.cc

#include <iostream.h>
#include "common/bvector.h"
#include "misc/delaynum.h"

delay_num::delay_num(const num_type &num)
	: bit_vector(num)
	{}

delay_num::delay_num(const delay_num &p)
	: common_base(p), dec_base(p), bit_vector(p)
	{}

delay_num *
delay_num::copy_constructor() const
	{ return new delay_num(*this); }

delay_num::dec_ostream_type &
delay_num::display(dec_ostream_type &s) const
	{
	s << '#' << to_string(num_type::BASE10) << ' ';
	return s;
	}

void
delay_num::sim_setup(const setup_type &setup)
	{ setup(this); }

void
delay_num::sim_trigger(const trigger_type &trigger)
	{ trigger(this); }

ostream &
operator<<(ostream &s, const delay_num &d)
	{ return d.display(s); }
