// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// delaynum.h
//
// Delay by constant number.

#ifndef _DELAYNUM_H
#define _DELAYNUM_H

#include "common/bvector.h"
#include "misc/decbase.h"

class delay_num : public dec_base, public bit_vector
	{
	friend struct setup_dec;
	friend struct trigger_dec;

public:
	typedef bit_vector num_type;
	typedef dec_base::ostream_type dec_ostream_type;

	delay_num(const num_type &);
	delay_num(const delay_num &);

	delay_num *copy_constructor() const;
	dec_ostream_type &display(dec_ostream_type &) const;
	void sim_setup(const setup_type &);
	void sim_trigger(const trigger_type &);
	};

ostream &operator<<(ostream &, const delay_num &);

#endif // _DELAYNUM_H
