// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// port.h

#ifndef _PORT_H
#define _PORT_H

#include "common/combase.h"

struct port_setup;

class port : public virtual common_base
	{
	friend struct setup_port;

public:
	typedef port_setup setup_type;

	port(const char *);

	const str_type &name() const;
	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);

private:
	str_type _name;
	};

ostream &operator<<(ostream &, const port &);

struct port_setup
	{
	virtual void operator()(port *) const {}
	};

#endif // _PORT_H
