// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// portconn.cc

#include "misc/portconn.h"

port_connection::port_connection(expr_type *e)
	{ _expr = e; }

port_connection::~port_connection()
	{ delete _expr; }

port_connection::ostream_type &
port_connection::display(ostream_type &s) const
	{ s << *_expr; return s; }

void
port_connection::sim_setup(const setup_type &setup)
	{ setup(this); }

ostream &
operator<<(ostream &s, const port_connection &d)
	{ return d.display(s); }
