// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// range.cc

#include "misc/range.h"

range::range(const cexpr_type *l, const cexpr_type *r)
	{
	_le = l->amount();
	_re = r->amount();
	}

range::range(const range &p)
	: common_base(p), select_base(p), _le(p._le), _re(p._re)
	{}

range::select_size_type
range::get_data(position_type &ms, position_type &ls) const
	{
	ms = (unsigned long)_le;
	ls = (unsigned long)_re;
	return select_type::SELECT_RANGE;
	}

range *
range::copy_constructor() const
	{ return new range(*this); }

range::ostream_type &
range::display(ostream_type &s) const
	{
	unsigned long ms = _le;
	unsigned long ls = _re;
	s << '[' << ms << ':' << ls << ']';
	return s;
	}

ostream &
operator<<(ostream &s, const range &r)
	{ return r.display(s); }
