// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// range.h

#ifndef _RANGE_H
#define _RANGE_H

#include "misc/selbase.h"
#include "misc/cexpr.h"

class range : public select_base
	{
public:
	typedef select_base select_type;
	typedef expr_base::num_type num_type;
	typedef const_expr cexpr_type;

	range(const cexpr_type *, const cexpr_type *);
	range(const range &);
	select_size_type get_data(position_type &, position_type &) const;
	range *copy_constructor() const;
	ostream_type &display(ostream &) const;

private:
	num_type _le;
	num_type _re;
	};

ostream &operator<<(ostream &, const range &);

#endif // _RANGE_H
