// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// selbase.h

#ifndef _SELBASE_H
#define _SELBASE_H

#include "common/combase.h"

class bit;

struct select_setup
	{
	virtual void operator()(bit *) const {}
	};

struct select_base : public virtual common_base
	{
	enum SELECT_SIZE { SELECT_BIT, SELECT_RANGE, SELECT_NONE };

	typedef signed long position_type;
	typedef SELECT_SIZE select_size_type;

	typedef select_setup setup_type;

	select_base()
		{}
	select_base(const select_base &s)
		: common_base(s) {}

	virtual select_size_type get_data(position_type &ms, position_type &ls) const
		{ ms = -1; ls = -1; return SELECT_NONE; }
	virtual select_base *copy_constructor() const
		{ return new select_base(*this); }
	virtual ostream_type &display(ostream &s) const
		{ return s; }
	virtual void sim_setup(const setup_type &)
		{}
	};

inline ostream &
operator<<(ostream &s, const select_base &sb)
	{ return sb.display(s); }

#endif // _SELBASE_H
