// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// cassign.cc

#include "moditm/cassign.h"

cont_assign::cont_assign(assign_stmt_list *a, dec_type *d)
	{ _dec = d; _assign = a; }

cont_assign::~cont_assign()
	{ delete _dec; delete _assign; }

cont_assign::ostream_type &
cont_assign::display(ostream_type &s) const
	{
	s << "assign ";
	if (_dec != 0)
		s << *_dec << ' ';
	assign_stmt_list::iterator itp(_assign->begin());
	assign_stmt_list::iterator stop(_assign->end());
	s << *(*itp) << ',' << endl;
	for (; itp != stop; ++itp)
		s << *(*itp) << ',' << endl;
	s << ';';
	return s;
	}

void
cont_assign::sim_setup(const setup_type &setup)
	{ setup(this); }

ostream &
operator<<(ostream &s, const cont_assign &d)
	{ return d.display(s); }
