// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// cassign.h

#ifndef _CASSIGN_H
#define _CASSIGN_H

#include <list>
#include "common/ptr.h"
#include "misc/decbase.h"
#include "moditm/mibase.h"
#include "stmt/bassign.h"

class cont_assign : public module_item_base
	{
	friend struct setup_module_item;

public:
	typedef dec_base dec_type;
	typedef block_assign_stmt assign_stmt;
	typedef basic_ptr<assign_stmt> assign_stmt_ptr;
	typedef list<assign_stmt_ptr> assign_stmt_list;

	typedef mitf_setup setup_type;

	cont_assign(assign_stmt_list *, dec_type * = 0);
	~cont_assign();

	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);

private:
	dec_type *_dec; // Optional delay control.
	assign_stmt_list *_assign;
	};

ostream &operator<<(ostream &, const cont_assign &);

#endif // _CASSIGN_H
