// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// d_setup.h

#ifndef _D_SETUP_H
#define _D_SETUP_H

#include <list>
#include "common/dstack.h"
#include "common/st_net.h"
#include "moditm/tfbase.h"

struct decl_setup
	{
	typedef Stack<int> scopelist_type;
	typedef tfdecl_base::range_type range_type;
	typedef tfdecl_base::ident_type ident_type;
	typedef basic_ptr<ident_type> ident_ptr;
	typedef list<ident_ptr> ident_list;
	typedef st_net net_type;
	typedef net_type::num_type num_type;
	typedef net_type::hash_type hash_type;
	typedef net_type::io_list io_list;
	typedef net_type::iodirection_type iodirection_type;
	typedef net_type::net_type type;

	decl_setup(scopelist_type &, io_list * = 0);
	void net_setup(ident_list *, range_type *, type) const;
	void io_setup(ident_list *, range_type *, iodirection_type) const;
	void operator()(reg_decl *) const;
	void operator()(wire_decl *) const;
	void operator()(input_decl *) const;
	void operator()(output_decl *) const;
	void operator()(inout_decl *) const;

	scopelist_type &_scope;
	io_list *_iovariable;
	};

#endif // _DSETUP_H
