// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// d_wire.h

#ifndef _D_WIRE_H
#define _D_WIRE_H

#include <list>
#include "common/ptr.h"
#include "moditm/tfbase.h"
#include "moditm/mibase.h"

class wire_decl : public module_item_base, public tfdecl_base
	{
	friend struct decl_setup;

public:
	typedef basic_ptr<ident_type> ident_ptr;
	typedef list<ident_ptr> ident_list;

	typedef mitf_setup setup_type;

	wire_decl(ident_list *, range_type * = 0);
	~wire_decl();

	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);

private:
	range_type *_range;
	ident_list *_id_list;
	};

ostream &operator<<(ostream &, const wire_decl &);

#endif // _D_WIRE_H
