// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// func.h

#ifndef _FUNC_H
#define _FUNC_H

#include <list>
#include "common/ptr.h"
#include "misc/range.h"
#include "stmt/stmtbase.h"
#include "moditm/tfbase.h"
#include "moditm/mibase.h"

class function : public module_item_base
	{
	friend struct setup_module_item;

public:
	typedef range range_type;
	typedef stmt_base stmt_type;
	typedef tfdecl_base decl_type;
	typedef basic_ptr<decl_type> decl_ptr;
	typedef list<decl_ptr> decl_list;

	typedef mitf_setup setup_type;

	function(const char *, stmt_type *, decl_list *, range_type * = 0);
	~function();

	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);

private:
	str_type _name;
	range_type *_retsize;
	stmt_type *_stmt;
	decl_list *_decl;
	};

ostream &operator<<(ostream &, const function &);

#endif // _FUNC_H
