// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// initial.cc

#include "moditm/initial.h"

initial::initial(stmt_type *s)
	{ _stmt = s; }

initial::~initial()
	{ delete _stmt; }

initial::ostream_type &
initial::display(ostream_type &s) const
	{
	s << "initial" << endl;
	return _stmt->display(s);
	}

void
initial::sim_setup(const setup_type &setup)
	{ setup(this); }

ostream &
operator<<(ostream &s, const initial &d)
	{ return d.display(s); }
