// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// initial.h

#ifndef _INITIAL_H
#define _INITIAL_H

#include "stmt/stmtbase.h"
#include "moditm/mibase.h"

class initial : public module_item_base
	{
	friend struct setup_module_item;

public:
	typedef stmt_base stmt_type;

	typedef mitf_setup setup_type;

	initial(stmt_type *);
	~initial();

	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);

private:
	stmt_type *_stmt;
	};

ostream &operator<<(ostream &, const initial &);

#endif // _INITIAL_H
