// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// mibase.h

#ifndef _MIBASE_H
#define _MIBASE_H

#include "common/combase.h"
#include "moditm/mitfsetup.h"

struct module_item_base : public virtual common_base
	{
	virtual ~module_item_base()
		{}
	virtual ostream_type &display(ostream_type &s) const
		{ return s; }
	virtual void sim_setup(const mitf_setup &)
		{}
	};

inline ostream &
operator<<(ostream &s, const module_item_base &d)
	{ return d.display(s); }

#endif // _MIBASE_H
