// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// misetup.h

#ifndef _MISETUP_H
#define _MISETUP_H

#include "common/event.h"
#include "stmt/stmtbase.h"
#include "moditm/mitfsetup.h"
#include "moditm/d_setup.h"

class st_module;
class st_function;
class st_task;

struct setup_module_item : public mitf_setup, public decl_setup
	{
	typedef list<hash_type> hash_list;
	typedef stmt_base stmt_type;
	typedef event_base<stmt_type> event_type;
	typedef event_type::event_container event_cache_type;
	typedef st_module module_type;
	typedef st_function func_type;
	typedef st_task task_type;

	setup_module_item(scopelist_type &, hash_list * = 0);

	void operator()(initial *) const;
	void operator()(always *) const;
	void operator()(cont_assign *) const;
	void operator()(function *) const;
	void operator()(task *) const;
	void operator()(module_instantiation *) const;
	// Front end for the declaration setup functions.
	void operator()(reg_decl *) const;
	void operator()(wire_decl *) const;
	void operator()(input_decl *) const;
	void operator()(output_decl *) const;
	void operator()(inout_decl *) const;
	};

#endif // _MISETUP_H
