// Verilog Behavioral Simulator
// Copyright (C) 1996 Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// mitfsetup.h

#ifndef _MITFSETUP_H
#define _MITFSETUP_H

class initial;
class always;
class cont_assign;
class function;
class task;
class module_instantiation;
class reg_decl;
class wire_decl;
class input_decl;
class output_decl;
class inout_decl;

struct mitf_setup
	{
	virtual void operator()(initial *) const {}
	virtual void operator()(always *) const {}
	virtual void operator()(cont_assign *) const {}
	virtual void operator()(function *) const {}
	virtual void operator()(task *) const {}
	virtual void operator()(module_instantiation *) const {}
	// Declarations.
	virtual void operator()(reg_decl *) const {}
	virtual void operator()(wire_decl *) const {}
	virtual void operator()(input_decl *) const {}
	virtual void operator()(output_decl *) const {}
	virtual void operator()(inout_decl *) const {}
	};

#endif // _MITFSETUP_H
