// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// tfbase.h

#ifndef _TFBASE_H
#define _TFBASE_H

#include "common/combase.h"
#include "misc/range.h"
#include "expr/rangeid.h"
#include "moditm/mitfsetup.h"

struct tfdecl_base : public virtual common_base
	{
	typedef range range_type;
	typedef range_id ident_type;

	virtual ~tfdecl_base()
		{}
	virtual ostream_type &display(ostream_type &s) const
		{ return s; }
	virtual void sim_setup(const mitf_setup &)
		{}
	};

inline ostream &
operator<<(ostream &s, const tfdecl_base &d)
	{ return d.display(s); }

#endif // _TFBASE_H
