/*
 * Verilog Behavioral Simulator
 * Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
 *
 * This file is part of the Verilog Behavioral Simulator package.
 * See the file COPYRIGHT for copyright and disclaimer information.
 * See the file COPYING for the licensing terms and conditions.
 * See the file CONTRIBUTORS for a list of contributing authors.
 *
 * p_expr.h
 *
 * Parser functions to create expression objects.
 */

#ifndef _P_EXPR_H
#define _P_EXPR_H

#ifdef __cplusplus
extern "C" {
#endif

#include "p_types.h"

extern p_expressionlist p_create_expressionlist(p_expressionlist, p_expression);
extern p_rangeidlist p_create_rangeidlist(p_rangeidlist, p_rangeid);
extern p_rangeid p_create_rangeid(char *, p_select);
extern p_qstring p_create_qstring(char *);
extern p_number p_create_number(char *);

extern p_add p_create_add(p_expression, p_expression);
extern p_subtract p_create_subtract(p_expression, p_expression);

extern p_invert p_create_invert(p_expression);
extern p_logand p_create_logand(p_expression, p_expression);
extern p_logor p_create_logor(p_expression, p_expression);
extern p_logxor p_create_logxor(p_expression, p_expression);
extern p_lshift p_create_lshift(p_expression, p_expression);
extern p_rshift p_create_rshift(p_expression, p_expression);

extern p_not p_create_not(p_expression);
extern p_eqeq p_create_eqeq(p_expression, p_expression);
extern p_noteq p_create_noteq(p_expression, p_expression);
extern p_lesthan p_create_lesthan(p_expression, p_expression);
extern p_leseq p_create_leseq(p_expression, p_expression);
extern p_grtthan p_create_grtthan(p_expression, p_expression);
extern p_grteq p_create_grteq(p_expression, p_expression);

extern p_grteq p_create_oror(p_expression, p_expression);
extern p_grteq p_create_andand(p_expression, p_expression);

extern p_funcenable p_create_funcenable(char *, p_expressionlist);

#ifdef __cplusplus
}
#endif

#endif /* _P_EXPR_H */
