/*
 * Verilog Behavioral Simulator
 * Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
 *
 * This file is part of the Verilog Behavioral Simulator package.
 * See the file COPYRIGHT for copyright and disclaimer information.
 * See the file COPYING for the licensing terms and conditions.
 * See the file CONTRIBUTORS for a list of contributing authors.
 *
 * p_misc.h
 *
 * Parser functions to create misc. objects.
 */

#ifndef _P_MISC_H
#define _P_MISC_H

#ifdef __cplusplus
extern "C" {
#endif

#include "p_types.h"

extern p_module p_create_module(char *, p_moduleitemlist, p_portlist);
extern p_portlist p_create_portlist(p_portlist, p_port);
extern p_port p_create_port(char *);

extern p_delayevntctl p_create_delaynum(p_number);
extern p_delayevntctl p_create_delayid(char *);
extern p_delayevntctl p_create_evntid(char *);
extern p_delayevntctl p_create_orevntexpr(p_evntexprlist);
extern p_evntexpr p_create_chngevntexpr(p_expression);
extern p_evntexpr p_create_posevntexpr(p_expression);
extern p_evntexpr p_create_negevntexpr(p_expression);
extern p_evntexprlist p_create_evntexprlist(p_evntexprlist, p_evntexpr);

extern p_constexpr p_create_constexpr(p_expression);
extern p_bit p_create_bit(p_expression);
extern p_range p_create_range(p_constexpr, p_constexpr);

#ifdef __cplusplus
}
#endif

#endif /* _P_MISC_H */
