/*
 * Verilog Behavioral Simulator
 * Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
 *
 * This file is part of the Verilog Behavioral Simulator package.
 * See the file COPYRIGHT for copyright and disclaimer information.
 * See the file COPYING for the licensing terms and conditions.
 * See the file CONTRIBUTORS for a list of contributing authors.
 *
 * p_moditm.h
 *
 * Parser functions to create module item objects.
 */

#ifndef _P_MODITM_H
#define _P_MODITM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "p_types.h"

extern p_portconn p_create_portconn(p_expression);
extern p_portconnlist p_create_portconnlist(p_portconnlist, p_portconn);
extern p_modinstance p_create_modinstance(const char *, p_portconnlist);
extern p_modinstancelist p_create_modinstancelist(p_modinstancelist,
                                                  p_modinstance);
extern p_tfdecllist p_create_tfdecllist(p_tfdecllist, p_tfdecl);
extern p_blkassignlist p_create_blkassignlist(p_blkassignlist, p_blkassignstmt);

extern p_moduleitemlist p_create_moduleitemlist(p_moduleitemlist, p_moduleitem);
extern p_initial p_create_initial(p_stmts);
extern p_always p_create_always(p_stmts);
extern p_regdecl p_create_regdecl(p_rangeidlist, p_range);
extern p_wiredecl p_create_wiredecl(p_rangeidlist, p_range);
extern p_inputdecl p_create_inputdecl(p_rangeidlist, p_range);
extern p_outputdecl p_create_outputdecl(p_rangeidlist, p_range);
extern p_inoutdecl p_create_inoutdecl(p_rangeidlist, p_range);
extern p_function p_create_function(const char *, p_stmts, p_tfdecllist,
	p_range);
extern p_task p_create_task(const char *, p_stmts, p_tfdecllist);
extern p_modinstan p_create_modinstan(const char *, p_modinstancelist);
extern p_contassign p_create_contassign(p_blkassignlist, p_delayevntctl);

#ifdef __cplusplus
}
#endif

#endif /* _P_MODITM_H */
