/*
 * Verilog Behavioral Simulator
 * Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
 *
 * This file is part of the Verilog Behavioral Simulator package.
 * See the file COPYRIGHT for copyright and disclaimer information.
 * See the file COPYING for the licensing terms and conditions.
 * See the file CONTRIBUTORS for a list of contributing authors.
 *
 * p_stmt.h
 *
 * Parser functions to create statement objects.
 */

#ifndef _P_STMTS_H
#define _P_STMTS_H

#ifdef __cplusplus
extern "C" {
#endif

#include "p_types.h"

extern p_lvalue p_create_lvalue(p_rangeid);
extern p_caseitem p_create_caseitem(p_expressionlist, p_stmts);
extern p_caseitemlist p_create_caseitemlist(p_expression, p_caseitemlist);

extern p_stmtslist p_create_stmtslist(p_stmtslist, p_stmts);
extern p_stmts p_create_stmts(void);
extern p_sequentialblock p_create_sequentialblock(p_stmtslist);
extern p_taskstmt p_create_taskstmt(char *, p_expressionlist);
extern p_blkassignstmt p_create_blkassignstmt(p_lvalue, p_expression);
extern p_nblkassignstmt p_create_nblkassignstmt(p_lvalue, p_expression);
extern p_ifstmt p_create_ifstmt(p_expression, p_stmts);
extern p_ifelsestmt p_create_ifelsestmt(p_expression, p_stmts, p_stmts);
extern p_forstmt p_create_forstmt(p_blkassignstmt, p_expression,
	p_blkassignstmt, p_stmts);
extern p_foreverstmt p_create_foreverstmt(p_stmts);
extern p_repeatstmt p_create_repeatstmt(p_expression, p_stmts);
extern p_whilestmt p_create_whilestmt(p_expression, p_stmts);
extern p_casestmt p_create_casestmt(p_expression, p_caseitemlist);

extern p_stmts p_create_includedec(p_stmts, p_delayevntctl);

#ifdef __cplusplus
}
#endif

#endif /* _P_STMTS_H */
