/*
 * Verilog Behavioral Simulator
 * Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
 *
 * This file is part of the Verilog Behavioral Simulator package.
 * See the file COPYRIGHT for copyright and disclaimer information.
 * See the file COPYING for the licensing terms and conditions.
 * See the file CONTRIBUTORS for a list of contributing authors.
 *
 * sim.h
 *
 * Functions that do all the work are moved out of the main driver
 * function and into the sim.cc file.  This header is included by
 * vbs.cc so it can call functions to do all the work.
 */

#ifndef _SIM_H
#define _SIM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "p_misc.h"

extern void sim_init(char *);
extern void sim_start(void);
extern void sim_perror(char *, char *, char *, char *, int);
extern void sim_debug(char *);
extern void sim_parsed_module(p_module m);

#ifdef __cplusplus
}
#endif

#endif /* _SIM_H */
