// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// bassign.h

#ifndef _BASSIGN_H
#define _BASSIGN_H

#include "expr/exprbase.h"
#include "stmt/stmtbase.h"
#include "stmt/lvalue.h"

class block_assign_stmt : public stmt_base
	{
	friend struct setup_stmt;
	friend struct trigger_stmt;

public:
	typedef lvalue lvalue_type;
	typedef expr_base expr_type;

	block_assign_stmt(lvalue_type *, expr_type *);
	block_assign_stmt(const block_assign_stmt &);
	~block_assign_stmt();

	void keep_dec(bool);
	block_assign_stmt *copy_constructor() const;
	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);
	bool sim_trigger(const trigger_type &);

private:
	lvalue_type *_lval;
	expr_type *_rval;
	};

ostream &operator<<(ostream &s, const block_assign_stmt &);

#endif // _BASSIGN_H
