// Verilog Behavioral Simulator
// Copyright (C) 1996 Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// Contributed by Udi Finkelstein, modified by Jimen Ching.
//
// forever.h

#ifndef _FOREVER_H
#define _FOREVER_H

#include "stmt/stmtbase.h"

class forever_stmt : public stmt_base
	{
	friend struct setup_stmt;
	friend struct trigger_stmt;

public:
	typedef stmt_base stmt_type;

	forever_stmt(stmt_type *);
	forever_stmt(const forever_stmt &);
	~forever_stmt();

	void keep_dec(bool);
	forever_stmt *copy_constructor() const;
	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);
	bool sim_trigger(const trigger_type &);

private:
	bool _delayed; // For delays in loops.
	stmt_type *_stmt;
	};

ostream &operator<<(ostream &, const forever_stmt &);

#endif // _FOREVER_H
