// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// if.h

#ifndef _IF_H
#define _IF_H

#include "expr/exprbase.h"
#include "stmt/stmtbase.h"

class if_stmt : public stmt_base
	{
	friend struct setup_stmt;
	friend struct trigger_stmt;

public:
	typedef expr_base expr_type;
	typedef stmt_base stmt_type;

	if_stmt(expr_type *, stmt_type *);
	if_stmt(const if_stmt &);
	~if_stmt();

	void keep_dec(bool);
	if_stmt *copy_constructor() const;
	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);
	bool sim_trigger(const trigger_type &);

private:
	expr_type *_expr;
	stmt_type *_stmt;
	};

ostream &operator<<(ostream &, const if_stmt &);

#endif // _IF_H
