// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// lvalue.cc

#include "stmt/lvalue.h"

lvalue::lvalue(ident_type *i)
	{ _ident = i; }

lvalue::lvalue(const lvalue &p)
	: common_base(p)
	{ _ident = new range_id(*p._ident); }

lvalue::~lvalue()
	{ delete _ident; }

lvalue::ostream_type &
lvalue::display(ostream_type &s) const
	{ s << *_ident; return s; }

void
lvalue::sim_setup(const setup_type &setup)
	{ setup(this); }

void
lvalue::sim_trigger(const trigger_type &trigger)
	{ trigger(this); }

ostream &
operator<<(ostream &s, const lvalue &d)
	{ return d.display(s); }
