// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// lvalue.h

#ifndef _LVALUE_H
#define _LVALUE_H

#include "expr/rangeid.h"

class st_node_base;
struct lvalue_setup;
struct lvalue_trigger;

class lvalue : public virtual common_base
	{
	friend struct setup_lvalue;
	friend struct trigger_lvalue;

public:
	typedef range_id ident_type;
	typedef st_node_base node_type;

	typedef lvalue_setup setup_type;
	typedef lvalue_trigger trigger_type;

	lvalue(ident_type *);
	lvalue(const lvalue &);
	~lvalue();

	ostream_type &display(ostream_type &) const;
	void sim_setup(const setup_type &);
	void sim_trigger(const trigger_type &);

protected:
	ident_type *_ident;
	};
ostream &operator<<(ostream &s, const lvalue &);

struct lvalue_setup
	{
	virtual void operator()(lvalue *) const {}
	};

struct lvalue_trigger
	{
	virtual void operator()(lvalue *) const {}
	};

#endif // _LVALUE_H
