// Verilog Behavioral Simulator
// Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
//
// This file is part of the Verilog Behavioral Simulator package.
// See the file COPYRIGHT for copyright and disclaimer information.
// See the file COPYING for the licensing terms and conditions.
// See the file CONTRIBUTORS for a list of contributing authors.
//
// time.cc

#include "stmt/time.h"

sysfunc_time::sysfunc_time()
	: _name("$time")
	{}

sysfunc_time::ostream_type &
sysfunc_time::display(ostream_type &s) const
	{ s << _name; return s; }

void
sysfunc_time::sim_setup(const setup_type &setup)
	{ setup(this); }

bool
sysfunc_time::sim_trigger(const trigger_type &trigger)
	{ return trigger(this); }

ostream &
operator<<(ostream &s, const sysfunc_time &ti)
	{ return ti.display(s); }
